###################################################
### chunk number 1: 
###################################################
library(wq)


###################################################
### chunk number 2:  eval=FALSE
###################################################
## sfbay <- read.csv("sfbay.csv", header = FALSE, as.is = TRUE, skip = 2)
## names(sfbay) <- c('date', 'time', 'stn', 'depth', 'chl', 'dox', 'spm', 'ext', 'sal', 'temp', 'nox', 'nhx')
## sfbay <- subset(sfbay, stn %in% c(21, 24, 27, 30, 32, 36) & substring(date, 7, 10) %in% 1985:2004)


###################################################
### chunk number 3: 
###################################################
head(sfbay)


###################################################
### chunk number 4: 
###################################################
x <- sample(1:nrow(sfbay), 10)
sfbay[x, "dox"]
sfbay1 <- transform(sfbay, dox = round(100 * dox/oxySol(sal, temp), 1))
sfbay1[x, "dox"]


###################################################
### chunk number 5: 
###################################################
sfb <- wqData(sfbay, c(1, 3:4), 5:12, site.order = TRUE, type = "wide", 
	time.format = "%m/%d/%Y")
head(sfb)


###################################################
### chunk number 6: 
###################################################
summary(sfb)


###################################################
### chunk number 7: 
###################################################
plot(sfb, vars = c('dox', 'temp'), num.col = 2)


###################################################
### chunk number 8: 
###################################################
print(plot(sfb, vars = c('dox', 'temp'), num.col = 2))


###################################################
### chunk number 9: 
###################################################
y <- tsMake(sfb, focus = "chl", layer = c(0, 5))
y[1:6, ]
tsp(y)
plot(y, main = "Chlorophyll in San Francisco Bay")


###################################################
### chunk number 10: 
###################################################
plot(y, main = "Chlorophyll in San Francisco Bay")


###################################################
### chunk number 11: 
###################################################
head(tsMake(sfb, focus = "chl", layer = c(0, 5), type = 'zoo'))


###################################################
### chunk number 12: 
###################################################
chl27 <- sfbayChla[, 's27']
tsp(chl27)
chl27 <- round(chl27, 1)
head(ts2df(chl27))


###################################################
### chunk number 13: 
###################################################
y <- window(sfbayChla, s=2005, end = c(2009, 12))  # 5 years, 16 sites
mts2ts(y, seas = 2:4)  # focus on Feb-Apr spring bloom


###################################################
### chunk number 14: 
###################################################
mannKen(Nile)


###################################################
### chunk number 15: 
###################################################
y <- sfbayChla
y1 <- tsSub(y, seas = c(1:7, 9:11))  # Aug and Dec often missing
y2 <- aggregate(y1, 1, mean, na.rm=FALSE)
mannKen(y)
mannKen(y, plot=TRUE, type='pct', order = TRUE)


###################################################
### chunk number 16: 
###################################################
print(mannKen(y, plot=TRUE, type='pct', order = TRUE))


###################################################
### chunk number 17: 
###################################################
chl27 <- sfbayChla[, "s27"]
seaKen(chl27)


###################################################
### chunk number 18: 
###################################################
seaRoll(chl27, w = 10)


###################################################
### chunk number 19: 
###################################################
x <- sfbayChla
seasonTrend(x, plot = TRUE, ncol = 4, scales = 'free_y')


###################################################
### chunk number 20: 
###################################################
print(seasonTrend(x, plot = TRUE, ncol = 4, scales = 'free_y'))


###################################################
### chunk number 21: 
###################################################
x <- sfbayChla[, 's27']
trendHomog(x)


###################################################
### chunk number 22: 
###################################################
chl <-sfbayChla[, 1:12]  # first 12 stations have good data coverage
seaKen(mts2ts(chl, 2:4))  # regional trend in spring bloom


###################################################
### chunk number 23: 
###################################################
chl27 <- sfbayChla[, "s27"]
chl27a <- interpTs(chl27, gap = 3)
plot(chl27a, col = "red", lwd = .5, xlab = "")
lines(chl27, col = "blue", lwd = 1.5)


###################################################
### chunk number 24: 
###################################################
plot(chl27a, col = "red", lwd = .5, xlab = "")
lines(chl27, col = "blue", lwd = 1.5)


###################################################
### chunk number 25: 
###################################################
chla1 <- aggregate(sfbayChla, 1, mean, na.rm = TRUE)
chla1 <- chla1[, 1:12]
eofNum(chla1, distr = "lognormal", reps = 2000)


###################################################
### chunk number 26: 
###################################################
print(eofNum(chla1, distr = "lognormal", reps = 2000))


###################################################
### chunk number 27: 
###################################################
e1 <- eof(chla1, n = 1)
e1


###################################################
### chunk number 28:  eval=FALSE
###################################################
## eofPlot(e1, type = "amp")


###################################################
### chunk number 29: 
###################################################
print(eofPlot(e1, type = "amp"))


###################################################
### chunk number 30: 
###################################################
chl27b <- interpTs(sfbayChla[, "s27"], gap = 3)
chl27b <- ts2df(chl27b, mon1 = 10, addYr = TRUE, omit = TRUE)
head(round(chl27b, 1))


###################################################
### chunk number 31: 
###################################################
e2 <- eof(chl27b, n = 2)
eofPlot(e2, type = "coef")


###################################################
### chunk number 32: 
###################################################
print(eofPlot(e2, type = "coef"))


###################################################
### chunk number 33: 
###################################################
chl27 <- sfbayChla[, "s27"]
d1 <- decompTs(chl27)
plot(d1, nc = 1, main = "Station 27 Chl-a decomposition")


###################################################
### chunk number 34: 
###################################################
plot(d1, nc = 1, main = "Station 27 Chl-a decomposition")


###################################################
### chunk number 35:  eval=FALSE
###################################################
## plotSeason(chl27, num.era = 3, same.plot = FALSE, ylab = 'Stn 27 Chl-a')


###################################################
### chunk number 36: 
###################################################
print(plotSeason(chl27, num.era = 3, same.plot = FALSE, ylab = 'Stn 27 Chl-a'))


###################################################
### chunk number 37:  eval=FALSE
###################################################
## plotSeason(chl27, num.era = 3, same.plot = TRUE, ylab = 'Stn 27 Chl-a')


###################################################
### chunk number 38: 
###################################################
print(plotSeason(chl27, num.era = 3, same.plot = TRUE, ylab = 'Stn 27 Chl-a'))


###################################################
### chunk number 39:  eval=FALSE
###################################################
## plotSeason(chl27, "by.month", ylab = 'Stn 27 Chl-a')


###################################################
### chunk number 40: 
###################################################
print(plotSeason(chl27, "by.month", ylab = 'Stn 27 Chl-a'))


###################################################
### chunk number 41: 
###################################################
chl27 <- sfbayChla[, 's27']
p1 <- phenoPhase(chl27)
head(p1)
p2 <- phenoPhase(chl27, c(1, 6))
head(p2)
p3 <- phenoAmp(chl27, c(1, 6))
head(p3)


###################################################
### chunk number 42: 
###################################################
zchl <- tsMake(sfb, focus = "chl", layer = c(0, 5), type = 'zoo')
head(zchl)
zchl27 <- zchl[, 3]
head(phenoPhase(zchl27))
head(phenoPhase(zchl27, c(1, 6), out = 'doy'))
head(phenoPhase(zchl27, c(1, 6), out = 'julian'))


###################################################
### chunk number 43: 
###################################################
chl27 <- sfbayChla[, "s27"]
plotTsTile(chl27)


###################################################
### chunk number 44: 
###################################################
print(plotTsTile(chl27))


###################################################
### chunk number 45:  eval=FALSE
###################################################
## chl27 = sfbayChla[, 's27']
## g1 <- plotTsTile(chl27, legend.title = 'Chl log-anomaly', 
##     square=FALSE)
## g2 <- seasonTrend(chl27, plot = TRUE, legend = TRUE)
## g3 <- plotSeason(chl27, num.era = 3, ylab = expression(paste('Chl-', italic(a), ', ', mu*g~L^{-1})))
## ## quartz("", 10, 6)  # e.g., in mac os x, or:
## ## grid.newpage()  # to re-use existing plot window
## layOut(list(g1, 1:2, 1:6), list(g2, 1:2, 7:10), list(g3, 3:5, 1:8))


###################################################
### chunk number 46: 
###################################################
chl27 = sfbayChla[, 's27']
g1 <- plotTsTile(chl27, legend.title = 'Chl log-anomaly', 
square=FALSE)
g2 <- seasonTrend(chl27, plot = TRUE, legend = TRUE)
g3 <- plotSeason(chl27, num.era = 3, ylab = expression(paste('Chl-', italic(a), ', ', mu*g~L^{-1})))
print(layOut(list(g1, 1:2, 1:6), list(g2, 1:2, 7:10), list(g3, 3:5, 1:8)))


